%macro   splist(ProfileId=EmployeeProfile,
              subset=,
              subsetvars=,
              breadcrumb=,
              title=
              );

%local varlist datasrc dsid nobs rc varlist;

%MACRO varlbls;
  %local var cnt;
  %do %until(&var=);
    %let cnt=%eval(&cnt+1);
    %let var=%scan(&varlist,&cnt,%str( ));
    attrib &var
    %lblfmt(hcm_col=&var);
    ;
  %end;
%mend;

ODS PATH work.templat(update) sasuser.templat(read)
sashelp.tmplmst(read);
proc template;
define tagset tagsets.newtag /store=work.templat;
 parent = tagsets.htmlcss ;
     define event doc_body;
       put '<body onload=javascript:window.print()>' ;
     end;
end;
 run;
ods tagsets.newtag body='main.html';

/* use profileid to get the datasouce from the profile table */
data _null_;
  set &hcmlib..employee_profile(where=(profileid="&profileid"));
      call symput('datasrc',datasource);
run;

/* use profileid to get the fields (attribute_value) from the*/
/* ProfileSummaryAttr table                                  */
data cols;
  set &hcmlib..profileSummaryAttr(where=(profileid="&profileid"));
run;

%let dsid=%sysfunc(open(cols));
%let nobs=%sysfunc(attrn(&dsid,nlobs));
%do i=1 %to &nobs;
  %let rc=%sysfunc(fetchobs(&dsid,&i));
  %let varlist=&varlist %sysfunc(getvarc(&dsid,%sysfunc(varnum(&dsid,AttributeValue))));
%end;
%let dsid=%sysfunc(close(&dsid));

/* Call bldview macro to apply security */
%bldview(intable=&datasrc, outtable=&datasrc, libref=&hcmlib, table_repository=HR);

%local newsub;
%let newsub=%substr(&subset,7);

data mysubset;
  set &datasrc;
  where %sysfunc(tranwrd(%nrbquote(&newsub), UPPER, UPCASE));
run;

data rpt(drop=fname lname);
  set mysubset (keep=%unquote(&varlist &subsetvars));
  %if %index(%upcase(&varlist),EMPLOYEE_NAME) >0 %then %do;
     index = index(employee_name, ",");
     if index ge 2 and length(employee_name) ge 2 then do;
       lname=substr(employee_name, 1, index-1);
       fname=left(substr(employee_name, index+1));
       employee_name=trim(fname) || ' ' || lname;
    end;
    drop index;
 %end;
run;

ods html nogtitle nogfootnote;

   proc print noobs uniform label;
   var &varlist;
   %varlbls;
   title1 height=6 "%nrbquote(&title)";
   title2 height=3 "%nrbquote(&breadcrumb)";
   footnote  height=3 "&sysdate9." "&systime.";
  run;
ods tagsets.newtag close;

%mend;
